	/** UsaAbb.java

	 Este software  livre e pode ser redistribudo e/ou modificado
	 sob os termos da GNU General Public License, como publicado pela
	 Free Software Foundation.
  
  	@author Renato de Souza-4 semestre-Engenharia de Computao
  	TODO email: renato.engcomp@gmail.com
  

	 Este programa possui propsitos educacionais, e implementa uma
	 interface bastante simples para manipulao de uma Abb,
	 implementada atravs da classe {@link Abb).

	*/

	import java.awt.*;
	import java.awt.event.*;
	import javax.swing.*;
	
public class UsaBusca extends JFrame  {

	Busca bDig;
	JLabel textoEntrada;
	JTextField entrada;
	JButton botaoInsere;
	JTextArea Saida;
	JTextArea Saida1;
	canvasDig canvas;



	    /** Inicia a classe UsaBusca criando uma rvore vazia e apresentando os
		componentes da Interface Grfica */
	    public UsaBusca() {
	    	bDig=new Busca();
	    	canvas=new canvasDig(bDig); 
	    	criaComponentes();

	    	setVisible(true); 
	    };


	    /** Mostra o contedo da arvore de busca Binaria */
	    private void mostra() {
	    	canvas.repaint();
		}


	    /** Cria, posiciona e inicia os componentes da Interface
		    grfica, como caixas de textos e botes */
	    private void criaComponentes() {

	        /** Altera o texto na barra de ttulo da Janela. */
	        setTitle("Programa Simples que Utiliza uma Busca Digital");

	        /** Cria o texto que ser mostrado acima da caixa de entrada */
	        textoEntrada = new JLabel("Entrada:");
	        
	        
			/** Cria a caixa de entrada para digitao dos elementos 
			    a serem inserido.
			    O tamanho da caixa de texto  de 10 caracteres. */
		entrada = new JTextField(10);
		
		entrada.addActionListener(new ActionListener() {
		        public void actionPerformed(ActionEvent evt) {
					
					    // Aqui deve ser colocado o cdigo a ser executado quando
						// o usurio clicar no boto.
		        		bDig.insere(entrada.getText());
		        		mostra();
		        		entrada.setText("");
		        	}
		        });

	        /** Cria o boto que ao ser clicado, empilha o elemento contido
			 na caixa de texto entrada. */
	        botaoInsere = new JButton();
	        botaoInsere.setText("Insere");
	        botaoInsere.addActionListener(new ActionListener() {
	        public void actionPerformed(ActionEvent evt) {
				
				    // Aqui deve ser colocado o cdigo a ser executado quando
					// o usurio clicar no boto.
	        		bDig.insere(entrada.getText());
	        		mostra();
	        		entrada.setText("");
	        	}
	        });
	        

	        /** Cria caixa de texto para mostrar o contedo da pilha (com 20 linhas e
			   50 colunas */
	        Saida = new JTextArea(2,50);
		Saida.setLineWrap(true);

		Saida1 = new JTextArea(1,50);
		Saida1.setLineWrap(true);


	        /** Determina como os elementos grficos devem ser posicionados
			 na Janela.	 */
			 
			Container principal = getContentPane();
			principal.setLayout(new BoxLayout(principal,BoxLayout.Y_AXIS));
			
			JPanel imput= new JPanel();
			imput.setLayout(new BoxLayout(imput,BoxLayout.X_AXIS));
			imput.add(textoEntrada);
			imput.add(entrada);
			
			principal.add(imput);
			
			/** O Cdigo abaixo  responsvel pelo alinhamento horizontal (X_AXIS) 
			    dos dois botes. Sem esse cdigos, os botes seriam alinhados
				horizontalmente (Y_AXIS) */			
			JPanel botoes = new JPanel();
			botoes.setLayout(new BoxLayout(botoes,BoxLayout.X_AXIS));
			botoes.add(botaoInsere);
			
			
			JPanel painel= new JPanel();
			painel.setLayout(new BoxLayout(painel,BoxLayout.X_AXIS));
			painel.add(canvas);
			
			principal.add(painel);
			principal.add(botoes);
			




			/** Posicionamento da Janela na Tela do Computador. */
	        setLocation(100,40);
	        setSize(450, 350);

	        pack();

	        /** Fecha o programa quando a janela  fechada. (Sem o cdigo abaixo,
			    a janela fecha mas o programa continua aberto - porm,s inacessvel) */	         addWindowListener(new java.awt.event.WindowAdapter() {
	            public void windowClosing(java.awt.event.WindowEvent evt) {
	                System.exit(0);
	            }
	        });
		}


		public static void main(String args[]) {
		    new UsaBusca();
		}


	}
